<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Learn Git</title>
</head>
<body>
    <h1>GIT</h1>
    <p>Git adalah version control system, yaitu sistem yang akan menyimpan perubahan file pada source code yang kita tulis. Sistem ini sangat berguna ketika kita melakukan development software secara kolaborasi atau kolektif. Selain itu git juga memudahkan kita untuk melacak perubahan apa saja yang telah dilakukan</p>
    <p>
        GIT juga memiliki penyedia layanan, antara lain :
        <ol>
            <li>Github</li>
            <li>Gitlab</li>
            <li>Bitbucket</li>
        </ol>
    </p>
    <p>
        Beberapa perintah git dasar adalah :
        <ul>
            <li>git init : untuk menginisialisasi repo</li>
            <li>git config : untuk melakukan konfigurasi terhadap git</li>
            <li>git status : untuk mengetahui status file yang ada di dalam repo (untracked, staging, modified)</li>
            <li>git add : untuk memasukkan file ke staging area</li>
            <li>git commit : untuk mencatat dan menyepakati perubahan yang dilakukan</li>
            <li>git log : untuk melihat riwayat commit</li>
        </ul>
    </p>
    <p>
        Kemudian perintah git yang berhubungan dengan server antara lain : 
        <ul>
            <li>git clone : untuk menduplikat atau mengunduh repo dari penyedia layanan</li>
            <li>git push : untuk mengunggah commit yang telah dibuat ke penyedia layanan</li>
            <li>git pull : untuk mengunduh commit yang ada di penyedia layanan (jika ada commit dari orang lain)</li>
            <li>git remote : untuk komunikasi antara client dan penyedia layanan</li>
        </ul>
    </p>
    <p>
        Pada git, ada istilah yang namanya branch. Sesuai namanya bracnh adalah cabang dari perubahan yang dibuat. Secara default cabang yang dibuat adalah master. Branch ini biasa digunakan ketika ingin berkolaborasi dengan orang lain, dan biasanya branch akan diberi nama orang yang berpartisipasi pada projek tersebut. Selain itu branch juga biasa digunakan ketika ingin mengembangkan fitur baru, sehingga tidak akan mempengaruhi cabang utama sebelum dilakukan merge (penggabungan).
    </p>
    <p>
        Perintah git yang digunakan untuk manajemen branch adalah :
        <ul>
            <li>git branch : untuk melihat seluruh branch pada repo lokal</li>
            <li>git branch --all : untuk melihat seluruh branch pada repo lokal dan repo server</li>
            <li>git branch nama_branch : untuk membuat branch baru</li>
            <li>git checkout nama_branch : untuk pindah posisi branch saat ini</li>
            <li>git branch -d nama_branch : untuk menghapus branch</li>
            <li>git merge nama_branch : untuk menggabungkan branch</li>
        </ul>
        Untuk melakukan merge branch, kita harus memastikan bahwa semua file sudah dilakukan commit sebelumnya.
    </p>
    <p>
        Ketika merge branch, ada suatu kondisi yang disebut conflict. Seperti namanya conflict terjadi ketika kedua branch melakukan modifikasi pada file yang sama, sehingga sistem git bingung akan menerapkan perubahan yang mana. Maka dari itu ketika terjadi conflict, maka kita tidak bisa melakukan commit dan harus menyelesaikan conflict terlebih dahulu. Caranya yaitu dengan memilih perubahan mana yang akan diterapkan pada file yang terjadi conflict.
    </p>
    <p>
        Terdapat sebuah aplikasi yang dapat dengan mudah melakukan semua fungsi git, tetapi secara GUI. Aplikasi tersebut bernama Sourcetree. Aplikasi ini sangat berguna karena memudahkan dan mempercepat kinerja developer dalam menggunakan git tanpa menggunakan CLI (terminal). Dengan aplikasi ini developer dapat menyelesaikan conflict secara cepat. Apalagi dengan menggunakan external tool bernama diff merge.
    </p>
</body>
</html>